from machine import Pin, time_pulse_us
import time

# Définir les broches pour le capteur ultrasonique
trig_pin = Pin(26, Pin.OUT)
echo_pin = Pin(27, Pin.IN)

# Définir les broches pour les LEDs
led_pin_20cm = Pin(3, Pin.OUT)
led_pin_40cm = Pin(4, Pin.OUT)
led_pin_60cm = Pin(2, Pin.OUT)

def get_distance():
    # Envoyer une impulsion de déclenchement
    trig_pin.value(1)
    time.sleep_us(10)
    trig_pin.value(0)

    # Mesurer la durée de l'impulsion écho
    duration = time_pulse_us(echo_pin, 1, 30000)  # 30ms timeout

    # Convertir la durée en distance (cm)
    if duration > 0:
        distance = duration / 58  # Conversion en cm (avec un facteur de 58)
    else:
        distance = -1  # Valeur invalide si la mesure a échoué
    return distance

while True:
    distance = get_distance()
    print("Distance:", distance, "cm")

    # Allumer les LEDs à différentes distances
    if distance == -1:
        led_pin_20cm.off() 
        led_pin_40cm.off() 
        led_pin_60cm.off()  
    elif distance <= 20:
        led_pin_20cm.on()  
        led_pin_40cm.off() 
        led_pin_60cm.off()  
    elif distance <= 40:
        led_pin_20cm.off()  
        led_pin_40cm.on()  
        led_pin_60cm.off()  
    elif distance <= 60:
        led_pin_20cm.off()  
        led_pin_40cm.off()  
        led_pin_60cm.on()  
    else:
        led_pin_20cm.off()  
        led_pin_40cm.off()  
        led_pin_60cm.off()  

    time.sleep(1)  # Attendre une seconde avant la prochaine mesure
